##########################################################################
#                                                                        #
#                         default_targets.mk                             #
#                                                                        #
##########################################################################
#                                                                        #
# Some default targets that are usefull for all Makefiles of this        #
# distribution                                                           #
#                                                                        #
##########################################################################
#                                                                        #
# Copyright (C) 2005  Research Institute for Symbolic Computation, J.    #
# Kepler University, Linz, Austria                                       #
#                                                                        #
# Written by Christian Aistleitner                                       #
#                                                                        #
# This program is free software; you can redistribute it and/or          #
# modify it under the terms of the GNU General Public License version 2, #
# as published by the Free Software Foundation.                          #
#                                                                        #
# This program is distributed in the hope that it will be useful,        #
# but WITHOUT ANY WARRANTY; without even the implied warranty of         #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
# GNU General Public License for more details.                           #
#                                                                        #
# You should have received a copy of the GNU General Public License      #
# along with this program; if not, write to the Free Software            #
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,             #
# MA  02110-1301, USA.                                                   #
#                                                                        #
##########################################################################

$(RECURSIVE_TARGETS):
	@CURRENTTARGET=`echo $@ | sed -e 's/-recursive$$//'` ;\
	for SUBDIR in $(SUBDIRS) ;\
	do \
	  echo "Making $$CURRENTTARGET in $$SUBDIR" ;\
	  (cd $$SUBDIR && make $$CURRENTTARGET) || exit 1;\
	  echo "Returning from $$CURRENTTARGET in $$SUBDIR" ;\
	done

%.ao:
	$(ALDOR) $(ALDORVARIANTOPTIONS) -Fao $<

%.o: %.ao 
	$(ALDOR) $(ALDORVARIANTOPTIONS) -Fo $<

% : %.o


############################################
# some helpers for doc targets

%.as-prepared: %.as
	$(SED) -e "=" $< | $(SED)-e 's/^//; N  ; s/^\(.*\)\n/\1: / ; s/^\([0-9]\):/ \1:/ ;  s/^\(.*\\.*\)$$/\\verb\"\1\" \\\\/ ; s/^\([^\\]*\)$$/\\verb\\\1\\ \\\\/ ;'  >$@

%.out:
	echo "\centerline{Output of {\tt./`echo $@ | sed 's/.out$$//;s/_/ /g'`}}\\\\" >$@ && echo "\\hline\\\\" >>$@ && ./`echo $@ | sed 's/.out$$//;s/_/ /g'` | $(SED)-e 's/^\(.*\)$$/\\verb\\\1\\\\\\/ ;'  >>$@ 

