-------------------------------------------------------------------------
--
-- eio_rsto.as
--
-------------------------------------------------------------------------
--
-- Copyright (C) 2005  Research Institute for Symbolic Computation, 
-- J. Kepler University, Linz, Austria
--
-- Written by Christian Aistleitner
-- 
-- This program is free software; you can redistribute it and/or          
-- modify it under the terms of the GNU General Public License version 2, 
-- as published by the Free Software Foundation.                          
-- 
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
-- MA  02110-1301, USA.
--

#include "aldor"

+++\begin{addescription}{provides functions for \Aldor's memory management.}
+++  This packages provides two functions. One function (\adname{printMemoryOverview}) is used to print an overview of the  used memory at runtime while the other function (\adname{invokeGarbageCollector}) is used to invoke \Aldor's garbage collector explcitely.
+++\end{addescription}
RuntimeStorage: with {

    +++\begin{addescription}{invokes \Aldor's garbage collector explictely.}
    +++  Calling \adthisname forces collection of garbage. This function is used typically, when \Aldor by itself is too lazy to collect garbage.
    +++\end{addescription}
    invokeGarbageCollector: () -> ();
    
    
    +++\begin{addescription}{prints an overview of currently allocated memory to \adname[TextWriter]{stderr}.}
    +++  This overview contains detailed information about allocated pages of memory and objects.
    +++\end{addescription}
    printMemoryOverview: () -> ();

} == add {
    
    -----------------------------------------

    import { 
	stoGc: () -> (); 
	stoShow: () -> ();
    } from Foreign C;
    
    -----------------------------------------

    invokeGarbageCollector(): () == {
	stoGc();
    }

    -----------------------------------------

    printMemoryOverview(): () == {
	stoShow();
    }
    
    -----------------------------------------

}